//button.c
#include "buttons.h"

void InitButtons(void)
{
  // button initialization
  PD5 |= 0x04;          //set P5.2 to output (button 1)
  PD5 |= 0x08;          //set P5.3 to output (button 2)
  PD6 |= 0x01;          //set P6.0 to output (button 3)
  PD6 |= 0x02;          //set P6.1 to output (button 4)
  
  P05 |= 0x04;          //set P5.2 to 1
  P05 |= 0x08;          //set P5.3 to 1
  P06 |= 0x01;          //set P6.0 to 1
  P06 |= 0x02;          //set P6.1 to 1  
}

void InitOW(void)
{
  //set port P6.2 and P6.3 to input  
  PD6 &= ~BIT2;
  PD6 &= ~BIT3;
}

void InitButInterupts()
{
  //disable interrupts
  __disable_interrupt();
  
  //enable interupts fot external interupts 10, 11, 12, 13
  EIE1_bit.EX10   = 1;    
  EIE1_bit.EX11   = 1;
  EIE1_bit.EX12   = 1;
  EIE1_bit.EX13   = 1;
  
  // Activate the interrupt request from module 1 where button is located
  IMR_bit.IM1 = 1;    // enable interrupts for module 1     
  
  //enable interupts
  __enable_interrupt();                     
}


#pragma vector = 1
__interrupt void ButtonInterrupt()
{
    

    // check for interrupt 10 (0x04) -> button 1
    if (EIF1 & 0x04) 
    { 
      Beep_1();
    }
    
    // check for interrupt 11 (0x08) -> button 2
    if (EIF1 & 0x08) 
    { 
      //put your function here to manupulate button 2 pressing 
      Beep_2();
    }
    
    // check for interrupt 12 (0x10) -> button 3
    if (EIF1 & 0x10) 
    { 
      LcdWriteChar(3, 'H');
      LcdWriteChar(4, 'E');
      LcdWriteChar(5, 'L');
      LcdWriteChar(6, 'L');
      LcdWriteChar(7, '0');
    }
    
    // check for interrupt 13 (0x20) -> button 4
    if (EIF1 & 0x20) 
    { 
      LcdWriteChar(3, 'M');
      LcdWriteChar(4, 'A');
      LcdWriteChar(5, 'X');
      LcdWriteChar(6, 'Q');
      LcdWriteChar(7, ' ');
    }
    
    EIF1 = 0;   //Disable Extarnal Interupt Flag   
}
