#include "lcd.h"

/**** LCD PARTS ****/
#define A   0x08    
#define B   0x04    
#define C   0x02    
#define D   0x01 
#define E   0x02    
#define F   0x04  
#define G   0x40
#define M   0x20  
#define H   0x80
#define J   0x80   
#define K   0x40
#define N   0x10
#define P   0x10
#define Q   0x20

//lcd small 1
#define b1  0x01 
#define g1  0x02 
#define c1  0x04 
#define d1  0x08 
#define a1  0x10 
#define f1  0x20 
#define e1  0x40 

//lcd small 2
#define a2  0x1 
#define b2  0x2 
#define c2  0x4 
#define d2  0x80 
#define f2  0x10
#define g2  0x20
#define e2  0x40


unsigned char FormatChar_1(unsigned char ch)
{

/*
  switch(ch)
  {
    case '0': return A+B+C+D; 
    case '1': return B+C; 
    case '2': return A+B+M+D; 
    case '3': return A+B+C+M+D;
    case '4': return B+C+M; 
    case '5': return A+M+C+D; 
    case '6': return A+M+C+D; 
    case '7': return A+B+C; 
    case '8': return A+B+C+M+D; 
    case '9': return A+B+C+M+D; 
    case 'A': return A+B+C+M; 
    case 'B': return A+K+M+C+D; 
    case 'C': return A+D; 
    case 'D': return D+N; 
    case 'E': return A+D; 
    case 'F': return A; 
    case 'G': return A+M+C+D; 
    case 'H': return B+M+C; 
    case 'I': return A+J+D; 
    case 'J': return B+C+D; 
    case 'K': return K+N; 
    case 'L': return D; 
    case 'M': return K+B+C; 
    case 'N': return N+B+C;
    case 'O': return A+B+C+D;
    case 'P': return A+B+M;
    case 'Q': return A+B+C+D+N;
    case 'R': return A+B+M+N;
    case 'S': return A+M+C+D;
    case 'T': return A+J;
    case 'U': return B+C+D;
    case 'V': return B+C+N;
    case 'W': return B+C+D;
    case 'X': return K+N;
    case 'Y': return B+M+C+D;
    case 'Z': return A+K+D;  
  }
*/ 
  
    if(ch == '0')      return A+B+C+D; 
    else if(ch == '1') return B+C; 
    else if(ch == '2') return A+B+M+D; 
    else if(ch == '3') return A+B+C+M+D;
    else if(ch == '4') return B+C+M; 
    else if(ch == '5') return A+M+C+D; 
    else if(ch == '6') return A+M+C+D; 
    else if(ch == '7') return A+B+C; 
    else if(ch == '8') return A+B+C+M+D; 
    else if(ch == '9') return A+B+C+M+D; 
    else if(ch == 'A') return A+B+C+M; 
    else if(ch == 'B') return A+K+M+C+D; 
    else if(ch == 'C') return A+D; 
    else if(ch == 'D') return D+N; 
    else if(ch == 'E') return A+D; 
    else if(ch == 'F') return A; 
    else if(ch == 'G') return A+M+C+D; 
    else if(ch == 'H') return B+M+C; 
    else if(ch == 'I') return A+J+D; 
    else if(ch == 'J') return B+C+D; 
    else if(ch == 'K') return K+N; 
    else if(ch == 'L') return D; 
    else if(ch == 'M') return K+B+C; 
    else if(ch == 'N') return N+B+C;
    else if(ch == 'O') return A+B+C+D;
    else if(ch == 'P') return A+B+M;
    else if(ch == 'Q') return A+B+C+D+N;
    else if(ch == 'R') return A+B+M+N;
    else if(ch == 'S') return A+M+C+D;
    else if(ch == 'T') return A+J;
    else if(ch == 'U') return B+C+D;
    else if(ch == 'V') return B+C+N;
    else if(ch == 'W') return B+C+N;
    else if(ch == 'X') return K+N;
    else if(ch == 'Y') return B+M+C+D;
    else if(ch == 'Z') return A+K+D;  
    else return 0;

}

unsigned char FormatChar_2(unsigned char ch)
{
/*
  switch(ch)
  { 
    case '0': return F+E; 
    case '1': return 0x0;
    case '2': return G+E; 
    case '3': return G; 
    case '4': return G+F;
    case '5': return G+F;
    case '6': return G+F+E;
    case '7': return 0x0;
    case '8': return G+F+E;
    case '9': return G+F; 
    case 'A': return E+F+G; 
    case 'B': return F+G+E; 
    case 'C': return F+E; 
    case 'D': return F+E+H;
    case 'E': return F+G+E;
    case 'F': return F+G+E;
    case 'G': return F+E; 
    case 'H': return F+G+E;
    case 'I': return P; 
    case 'J': return E; 
    case 'K': return F+G+E; 
    case 'L': return F+E; 
    case 'M': return F+E+H; 
    case 'N': return F+E+H; 
    case 'O': return F+E;
    case 'P': return F+G+E;
    case 'Q': return F+E; 
    case 'R': return F+G+E;
    case 'S': return F+G;
    case 'T': return P;
    case 'U': return F+E;
    case 'V': return H;
    case 'W': return P+F+E;
    case 'X': return H+Q;
    case 'Y': return F+G;
    case 'Z': return Q;   
*/

    if(ch == '0')      return F+E; 
    else if(ch == '1') return 0x0;
    else if(ch == '2') return G+E; 
    else if(ch == '3') return G; 
    else if(ch == '4') return G+F;
    else if(ch == '5') return G+F;
    else if(ch == '6') return G+F+E;
    else if(ch == '7') return 0x0;
    else if(ch == '8') return G+F+E;
    else if(ch == '9') return G+F; 
    else if(ch == 'A') return E+F+G; 
    else if(ch == 'B') return F+G+E; 
    else if(ch == 'C') return F+E; 
    else if(ch == 'D') return F+E+H;
    else if(ch == 'E') return F+G+E;
    else if(ch == 'F') return F+G+E;
    else if(ch == 'G') return F+E; 
    else if(ch == 'H') return F+G+E;
    else if(ch == 'I') return P; 
    else if(ch == 'J') return E; 
    else if(ch == 'K') return F+G+E; 
    else if(ch == 'L') return F+E; 
    else if(ch == 'M') return F+E+H; 
    else if(ch == 'N') return F+E+H; 
    else if(ch == 'O') return F+E;
    else if(ch == 'P') return F+G+E;
    else if(ch == 'Q') return F+E; 
    else if(ch == 'R') return F+G+E;
    else if(ch == 'S') return F+G;
    else if(ch == 'T') return P;
    else if(ch == 'U') return F+E;
    else if(ch == 'V') return H;
    else if(ch == 'W') return Q+F+E;
    else if(ch == 'X') return H+Q;
    else if(ch == 'Y') return F+G;
    else if(ch == 'Z') return Q;  
    else return 0;
    
}


void LcdWriteChar(unsigned short pos, unsigned char letter)
{
/*
    switch(pos)
    {
      case 3: LCD0 = FormatChar_2(letter); LCD1 = FormatChar_1(letter); break;
      case 4: LCD2 = FormatChar_2(letter); LCD3 = FormatChar_1(letter); break;
      case 5: LCD4 = FormatChar_2(letter); LCD5 = FormatChar_1(letter); break;
      case 6: LCD6 = FormatChar_2(letter); LCD7 = FormatChar_1(letter); break;          
      case 7: LCD8 = FormatChar_2(letter); LCD9 = FormatChar_1(letter); break;       
    }
*/

    
    if(pos == 3)      { LCD0 = FormatChar_2(letter); LCD1 = FormatChar_1(letter); }
    else if(pos == 4) { LCD2 = FormatChar_2(letter); LCD3 = FormatChar_1(letter); }
    else if(pos == 5) { LCD4 = FormatChar_2(letter); LCD5 = FormatChar_1(letter); }
    else if(pos == 6) { LCD6 = FormatChar_2(letter); LCD7 = FormatChar_1(letter); }          
    else if(pos == 7) { LCD8 = FormatChar_2(letter); LCD9 = FormatChar_1(letter); }       
}
                                       
void LcdWriteWord(unsigned char *word)
{
    //int i=0;
    //for(i=3; i<8; i++)
    //{
    //  WriteChar(i, word[i-3]);
    //}
    
    LcdWriteChar(3, word[0]);
    LcdWriteChar(4, word[1]);
    LcdWriteChar(5, word[2]);
    LcdWriteChar(6, word[3]);
    LcdWriteChar(7, word[4]);
    
}

unsigned char FormatNumber_1(int num)
{
  if(num == 0)        return a1+b1+c1+d1+e1+f1;
  else if(num == 1)   return c1+b1;
  else if(num == 2)   return a1+b1+g1+e1+d1;
  else if(num == 3)   return a1+b1+c1+d1+g1;
  else if(num == 4)   return f1+g1+b1+c1;
  else if(num == 5)   return a1+f1+g1+c1+d1;
  else if(num == 6)   return a1+c1+d1+e1+f1+g1;
  else if(num == 7)   return a1+b1+c1;
  else if(num == 8)   return a1+b1+c1+d1+e1+f1+g1;
  else if(num == 9)   return a1+b1+c1+d1+f1+g1;
  else return 0x0;
}

unsigned char FormatNumber_2(int num)
{
  if(num == 0)        return a2+b2+c2+d2+e2+f2;
  else if(num == 1)   return c2+b2;
  else if(num == 2)   return a2+b2+g2+e2+d2;
  else if(num == 3)   return a2+b2+c2+d2+g2;
  else if(num == 4)   return f2+g2+b2+c2;
  else if(num == 5)   return a2+f2+g2+c2+d2;
  else if(num == 6)   return a2+c2+d2+e2+f2+g2;
  else if(num == 7)   return a2+b2+c2;
  else if(num == 8)   return a2+b2+c2+d2+e2+f2+g2;
  else if(num == 9)   return a2+b2+c2+d2+f2+g2;
  else return 0x0;
}

void LcdWriteClck(unsigned int number)
{
    int edi, des, sto, hil;
    
    edi = (number%10);
    des = (number%100 - edi)/10;
    sto = (number%1000 - des)/100;
    hil = (number%10000 - sto)/1000;
    
    LCD10 = FormatNumber_1(edi); 
    LCD11 = FormatNumber_1(des);
    LCD12 = FormatNumber_2(sto);
    LCD13 = FormatNumber_2(hil);
}

void clearLCD(void) 
{
  //clear all LCD register 
  LCD0 = 0x0;     LCD1 = 0x0;     LCD2 = 0x0;     LCD3 = 0x0;
  LCD4 = 0x0;     LCD5 = 0x0;     LCD6 = 0x0;     LCD7 = 0x0;
  LCD8 = 0x0;     LCD9 = 0x0;     LCD10 = 0x0;    LCD11 = 0x0;  
  LCD12 = 0x0;    LCD13 = 0x0;    LCD14 = 0x0;    LCD15 = 0x0;
  LCD16 = 0x0;  
}

void allLCD(void)
{
  //enable all LCD register
  LCD0 = 0xff;    LCD1 = 0xff;    LCD2 = 0xff;    LCD3 = 0xff;
  LCD4 = 0xff;    LCD5 = 0xff;    LCD6 = 0xff;    LCD7 = 0xff;
  LCD8 = 0xff;    LCD9 = 0xff;    LCD10 = 0xff;   LCD11 = 0xff;  
  LCD12 = 0xff;   LCD13 = 0xff;   LCD14 = 0xff;   LCD15 = 0xff;
  LCD16 = 0xff;
}
                    
void initLCD(void)
{
  ///////  Set LCD Display mode ////////
  //Set Duty0 to 1, set Duty1 to 1
  //Set DUTY CYCLE -> 1/4 (use COM0-COM3)
  //Set BIAS MODE -> 1/3 (display contrast)
  //LCRA_bit.DUTY = 0x3;
  //
  //Set LRA to 0 (Internal Resistor -> 200K)
  //LCRA_bit.LRA = 0x0; 
  // 
  //Set clock source to 32KHz external clock.
  //LCRA_bit.LCCS = 0x0;
  //
  //Set frame frequency
  //LCRA_bit.FRM = 0x1;
  //
  //Set connected to ground interally
  //LCRA_bit.LRIGC = 0x1;
  //
  //whit one row
  //LCRA = 0x1BA0; 
  LCRA = 0x1FE0;
  
  ////// Enable LCD Controler ///// 
  LCFG_bit.DPE = 1; 
  LCFG_bit.OPM = 1;
  
  ////// Set All ports to LCD segment output ///// 
  LCFG_bit.PCF = 0x1f;
} 

