//rtc.c
#include "rtc.h"

void InitRTC()
{
    RCNT = 0x0000;                        // turn on the 32kHz
    while (RCNT & 0x08) {}                // wait for bisy flag
    RCNT = 0x8000;                        // write enable the real-time clock enable bit
    RCNT = 0x8001;                        // start the real time clock
    RCNT = 0xC001;                        // enable external clock
    RCNT = 0xE001;                        // enable ACS clock
    RCNT = 0x0001;                        // turn off RTCE write access 
}

unsigned long RTCGetseconds()
{
    unsigned long seconds = RTSH;
    seconds = seconds << 16;
    seconds = seconds | RTSL;
    return seconds;
}

void InitRTCInterupts()
{
  //disable interrupts
  __disable_interrupt();
  
  //enable interupts fot RDY
  //RCNT_bit.RDYE = 1;
  
  //enable interupts fot ADE and ASE
  RCNT_bit.ASE = 1;
  RCNT_bit.ADE = 1;
  
  // Activate the interrupt request from module 4 
  IMR_bit.IM0 = 1;    // enable interrupts for module 4     
  
  //enable interupts
  __enable_interrupt();                     
}


#pragma vector = 0
__interrupt void RTCInterrupt()
{

  LcdWriteClck(RTCGetseconds() % 20000);    //Get seconds and print

  //from here 
  RCNT = RCNT & 0xFF7F;                     //Clear intrupt register
 
  
}

